﻿Imports NinjaDomain.Classes
Imports System.Data.Entity
Imports System.Text
Imports System.Threading.Tasks

Namespace NinjaDomain.DataModel
  Public Class DataHelpers
	Public Shared Sub NewDbWithSeed()

	  Database.SetInitializer(New DropCreateDatabaseAlways(Of NinjaContext)())
	  Using context = New NinjaContext()
		If context.Ninjas.Any() Then
		  Exit Sub
		End If
		Dim vtClan = context.Clans.Add(New Clan With {.ClanName = "Vermont Clan"})
		Dim turtleClan = context.Clans.Add(New Clan With {.ClanName = "Turtles"})
		Dim amClan = context.Clans.Add(New Clan With {.ClanName = "American Ninja Warriors"})

		Dim j = New Ninja With {.Name = "JulieSan", .ServedInOniwaban = False, .DateOfBirth = New Date(1980, 1, 1), .Clan = vtClan}
		Dim s = New Ninja With {.Name = "SampsonSan", .ServedInOniwaban = False, .DateOfBirth = New Date(2008, 1, 28), .ClanId = 1}
		Dim l = New Ninja With {.Name = "Leonardo", .ServedInOniwaban = False, .DateOfBirth = New Date(1984, 1, 1), .Clan = turtleClan}
		Dim r = New Ninja With {.Name = "Raphael", .ServedInOniwaban = False, .DateOfBirth = New Date(1985, 1, 1), .Clan = turtleClan}
		context.Ninjas.AddRange(New List(Of Ninja) From {j, s, l, r})
		Dim ninjaKC = New Ninja With {.Name = "Kacy Catanzaro", .ServedInOniwaban = False, .DateOfBirth = New Date(1990, 1, 14), .Clan = amClan}
		Dim muscles = New NinjaEquipment With {.Name = "Muscles", .Type = EquipmentType.Tool}
		Dim spunk = New NinjaEquipment With {.Name = "Spunk", .Type = EquipmentType.Weapon}

		ninjaKC.EquipmentOwned.Add(muscles)
		ninjaKC.EquipmentOwned.Add(spunk)
		context.Ninjas.Add(ninjaKC)

		context.SaveChanges()
		context.Database.ExecuteSqlCommand("CREATE PROCEDURE GetOldNinjas" & ControlChars.CrLf & "                    AS  SELECT * FROM Ninjas WHERE DateOfBirth<='1/1/1980'")

		context.Database.ExecuteSqlCommand("CREATE PROCEDURE DeleteNinjaViaId" & ControlChars.CrLf & "                     @Id int" & ControlChars.CrLf & "                     AS" & ControlChars.CrLf & "                     DELETE from Ninjas Where Id = @id" & ControlChars.CrLf & "                     RETURN @@rowcount")
	  End Using
	End Sub
  End Class
End Namespace

