﻿Imports NinjaDomain.Classes
Imports System.Data.Entity
Imports NinjaDomain.Classes.Interfaces

Namespace NinjaDomain.DataModel
  Public Class NinjaContext
	  Inherits DbContext
	Public Property Ninjas() As DbSet(Of Ninja)
	Public Property Clans() As DbSet(Of Clan)
	Public Property Equipment() As DbSet(Of NinjaEquipment)

	Protected Overrides Sub OnModelCreating(ByVal modelBuilder As DbModelBuilder)
	  modelBuilder.Types().Configure(Function(c) c.Ignore("IsDirty"))
	  MyBase.OnModelCreating(modelBuilder)
	End Sub

	Public Overrides Function SaveChanges() As Integer
	  For Each history In Me.ChangeTracker.Entries().Where(Function(e) TypeOf e.Entity Is IModificationHistory AndAlso (e.State = EntityState.Added OrElse e.State = EntityState.Modified)).Select(Function(e) TryCast(e.Entity, IModificationHistory))
		history.DateModified = Date.Now
		If history.DateCreated = Date.MinValue Then
		  history.DateCreated = Date.Now
		End If
	  Next history
	  Dim result As Integer = MyBase.SaveChanges()
	  For Each history In Me.ChangeTracker.Entries().Where(Function(e) TypeOf e.Entity Is IModificationHistory).Select(Function(e) TryCast(e.Entity, IModificationHistory))
		history.IsDirty = False
	  Next history
	  Return result
	End Function
  End Class
End Namespace
