﻿Imports System.Net.Http.Headers
Imports System.Web.Http
Imports System.Web.Http.Cors
Imports Newtonsoft.Json

Namespace WebAPI
  Public NotInheritable Class WebApiConfig
	Private Sub New()
	End Sub
	Public Shared Sub Register(ByVal config As HttpConfiguration)
	  ' Web API configuration and services
	  config.Formatters.JsonFormatter.SupportedMediaTypes.Add(New MediaTypeHeaderValue("text/html"))
	  config.Formatters.JsonFormatter.SerializerSettings.ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Ignore
	  config.Formatters.JsonFormatter.SerializerSettings.PreserveReferencesHandling = Newtonsoft.Json.PreserveReferencesHandling.None

	  Dim cors = New EnableCorsAttribute("*", "*", "*")
	  config.EnableCors(cors)
	  ' Web API routes
	  config.MapHttpAttributeRoutes()

	  config.Routes.MapHttpRoute(name:= "CreateDbApi", routeTemplate:= "api/Ninjas/CreateDatabase", defaults:= New With {Key .Controller = "Ninjas", Key .Action = "CreateDatabase"})


	  config.Routes.MapHttpRoute(name:= "DefaultApi", routeTemplate:= "api/{controller}/{id}", defaults:= New With {Key .id = RouteParameter.Optional})


	End Sub
  End Class
End Namespace
