﻿Imports System.Web.Http
Imports Newtonsoft.Json
Imports NinjaDomain.Classes
Imports NinjaDomain.DataModel

Namespace WebAPI.Controllers
  Public Class NinjasController
	  Inherits ApiController
	Private ReadOnly _repo As New DisconnectedRepository()

	Public Function [Get](Optional ByVal query As String = "", Optional ByVal page As Integer = 0, Optional ByVal pageSize As Integer = 20) As IEnumerable(Of ViewListNinja)
	  Dim ninjas = _repo.GetQueryableNinjasWithClan(query, page, pageSize)
	  Return ninjas.Select(Function(n) New ViewListNinja With {.ClanName = n.Clan.ClanName, .DateOfBirth = n.DateOfBirth, .Id = n.Id, .Name = n.Name, .ServedInOniwaban = n.ServedInOniwaban})
	End Function

	Public Function [Get](ByVal id As Integer) As Ninja
	  Return _repo.GetNinjaWithEquipmentAndClan(id)
	End Function

	Public Sub Post(<FromBody> ByVal ninja As Object)
	  Dim asNinja = JsonConvert.DeserializeObject(Of Ninja)(ninja.ToString())

	  _repo.SaveUpdatedNinja(asNinja)
	End Sub

	Public Sub Put(ByVal id As Integer, <FromBody> ByVal ninja As Ninja)
	  _repo.SaveNewNinja(ninja)
	End Sub


	Public Sub Delete(ByVal id As Integer)
	  _repo.DeleteNinja(id)
	End Sub

	<ActionName("CreateDatabase"), AcceptVerbs("GET")>
	Public Sub CreateDatabase(ByVal truth As String)
	  DataHelpers.NewDbWithSeed()
	End Sub

  End Class
End Namespace